/************************************************************
Program Name: Midpoint.do
Program Creator: Joseph Song
Date: 4-16-2010
Description: Creates mean and variance using the midpoint formula

input: gdpAroll.dta
       gdpBroll.dta

output: gdpAroll.dta
        gdpBroll.dta

Creates "diagnostic" variables which we can use to exclude
individual forecasters.
   
***************************************************************/

clear all

local file "gdpAroll gdpBroll gdpfiveyr"
foreach x of local file {

use $data/`x'.dta, clear


/* Creates Midpoints of each bin */
/* Number of bins differ across time */


foreach i of numlist 1(1)22 {
	gen mid`i' = .
}

replace mid1 = -0.5 if group == 1
replace mid2 = 0.2 if group == 1
replace mid3 = 0.7 if group == 1
replace mid4 = 1.2 if group == 1
replace mid5 = 1.7 if group == 1
replace mid6 = 2.2 if group == 1
replace mid7 = 2.7 if group == 1
replace mid8 = 3.2 if group == 1
replace mid9 = 3.7 if group == 1
replace mid10 = 4.5 if group == 1
replace mid11 = . if group == 1
replace mid12 = . if group == 1
replace mid13 = . if group == 1
replace mid14 = . if group == 1
replace mid15 = . if group == 1
replace mid16 = . if group == 1
replace mid17 = . if group == 1
replace mid18 = . if group == 1
replace mid19 = . if group == 1
replace mid20 = . if group == 1
replace mid21 = . if group == 1
replace mid22 = . if group == 1


replace mid1 = -0.5 if group == 2
replace mid2 = 0.2 if group == 2
replace mid3 = 0.7 if group == 2
replace mid4 = 1.2 if group == 2
replace mid5 = 1.7 if group == 2
replace mid6 = 2.2 if group == 2
replace mid7 = 2.7 if group == 2
replace mid8 = 3.2 if group == 2
replace mid9 = 3.7 if group == 2
replace mid10 = 4.2 if group == 2
replace mid11 = 4.7 if group == 2
replace mid12 = 5.5 if group == 2
replace mid13 = . if group == 2
replace mid14 = . if group == 2
replace mid15 = . if group == 2
replace mid16 = . if group == 2
replace mid17 = . if group == 2
replace mid18 = . if group == 2
replace mid19 = . if group == 2
replace mid20 = . if group == 2
replace mid21 = . if group == 2
replace mid22 = . if group == 2

replace mid1 = -1.5 if group == 3
replace mid2 = -0.8 if group == 3
replace mid3 = -0.3 if group == 3
replace mid4 = 0.2 if group == 3
replace mid5 = 0.7 if group == 3
replace mid6 = 1.2 if group == 3
replace mid7 = 1.7 if group == 3
replace mid8 = 2.2 if group == 3
replace mid9 = 2.7 if group == 3
replace mid10 = 3.2 if group == 3
replace mid11 = 3.7 if group == 3
replace mid12 = 4.5 if group == 3
replace mid13 = . if group == 3
replace mid14 = . if group == 3
replace mid15 = . if group == 3
replace mid16 = . if group == 3
replace mid17 = . if group == 3
replace mid18 = . if group == 3
replace mid19 = . if group == 3
replace mid20 = . if group == 3
replace mid21 = . if group == 3
replace mid22 = . if group == 3

replace mid1 = -6.5 if group == 4
replace mid2 = -5.8 if group == 4
replace mid3 = -5.3 if group == 4
replace mid4 = -4.8 if group == 4
replace mid5 = -4.3 if group == 4
replace mid6 = -3.8 if group == 4
replace mid7 = -3.3 if group == 4
replace mid8 = -2.8 if group == 4
replace mid9 = -2.3 if group == 4
replace mid10 = -1.8 if group == 4
replace mid11 = -1.3 if group == 4
replace mid12 = -0.8 if group == 4
replace mid13 = -0.3 if group == 4
replace mid14 = 0.2 if group == 4
replace mid15 = 0.7 if group == 4
replace mid16 = 1.2 if group == 4
replace mid17 = 1.7 if group == 4
replace mid18 = 2.2 if group == 4
replace mid19 = 2.7 if group == 4
replace mid20 = 3.2 if group == 4
replace mid21 = 3.7 if group == 4
replace mid22 = 4.5 if group == 4

   
gen mmid = a1*mid1 + a2*mid2 + a3*mid3 + a4*mid4 + a5*mid5 + a6*mid6 + a7*mid7 + a8*mid8 + a9*mid9 + a10*mid10 if group == 1
replace mmid = a1*mid1 + a2*mid2 + a3*mid3 + a4*mid4 + a5*mid5 + a6*mid6 + a7*mid7 + a8*mid8 + a9*mid9 + a10*mid10 + a11*mid11 + a12*mid12 if group == 2 | group == 3
replace mmid = a1*mid1 + a2*mid2 + a3*mid3 + a4*mid4 + a5*mid5 + a6*mid6 + a7*mid7 + a8*mid8 + a9*mid9 + a10*mid10 + a11*mid11 + a12*mid12 + a13*mid13 + a14*mid14 + a15*mid15 + a16*mid16 + a17*mid17 + a18*mid18 + a19*mid19 + a20*mid20 + a21*mid21 + a22*mid22 if group == 4

   
gen vmid = a1*(mid1-mmid)^2 + a2*(mid2-mmid)^2 + a3*(mid3-mmid)^2 + a4*(mid4-mmid)^2 + a5*(mid5-mmid)^2 + a6*(mid6-mmid)^2 + a7*(mid7-mmid)^2 + a8*(mid8-mmid)^2 + a9*(mid9-mmid)^2 + a10*(mid10-mmid)^2 if group == 1
replace vmid = a1*(mid1-mmid)^2 + a2*(mid2-mmid)^2 + a3*(mid3-mmid)^2 + a4*(mid4-mmid)^2 + a5*(mid5-mmid)^2 + a6*(mid6-mmid)^2 + a7*(mid7-mmid)^2 + a8*(mid8-mmid)^2 + a9*(mid9-mmid)^2 + a10*(mid10-mmid)^2 + a11*(mid11-mmid)^2 + a12*(mid12-mmid)^2 if group == 2 | group == 3
replace vmid = a1*(mid1-mmid)^2 + a2*(mid2-mmid)^2 + a3*(mid3-mmid)^2 + a4*(mid4-mmid)^2 + a5*(mid5-mmid)^2 + a6*(mid6-mmid)^2 + a7*(mid7-mmid)^2 + a8*(mid8-mmid)^2 + a9*(mid9-mmid)^2 + a10*(mid10-mmid)^2 + a11*(mid11-mmid)^2 + a12*(mid12-mmid)^2 + a13*(mid13-mmid)^2 + a14*(mid14-mmid)^2 + a15*(mid15-mmid)^2 + a16*(mid16-mmid)^2 + a17*(mid17-mmid)^2 + a18*(mid18-mmid)^2 + a19*(mid19-mmid)^2 + a20*(mid20-mmid)^2 + a21*(mid21-mmid)^2 + a22*(mid22-mmid)^2 if group == 4


gen smid = sqrt(vmid)

drop mid*

label var mmid "Mean of the density forecast using the midpoint formula"
label var vmid "Variance of the density forecast using the midpoint formula"
label var smid "Standard Deviation of the density forecast using the midpoint formula"
   
gen nopoint = 0
replace nopoint = 1 if point == .

egen total = rowtotal(a1-a22)

gen sum0 = 0
replace sum0 = 1 if total == 0
label variable sum0 "missing density forecast"

gen sum1 = 0
replace sum1=1 if total <=.991  | total >=1.009
label variable sum1 "probabilities do not sum to unity"

gen kooky = 0
replace kooky=1 if abs(mmid-point)>0.5 & sum1==0 & sum0==0 & nopoint==0
label variable kooky "discrepancy between point and density forecasts greater than 1.5%"

save, replace

}

cd $main
