/************************************************************************
   Tail_Bin_Count_HICP.do
   10/26/10
   Joseph Song

   Description: Create percentile by individual forecast distribution

   *********************************************************************/
#delimit ;
clear;
set mem 100000;
set more off;

local data "A B 5";
foreach sampcut in 5 10 15 20 25 100 {;
foreach x of local data {;

   use output/hicp/laxhicp_Percentile`x'_`sampcut'.dta, clear;

   gen count = 1;
   bysort ydate qdate: egen MinBin = sum(count) if Bin1 == 1;
   bysort ydate qdate: egen LowBin = sum(count) if Bin20 == 1;
   bysort ydate qdate: egen HighBin1 = count(count) if group == 1 & Bin80 == 9;
   bysort ydate qdate: egen HighBin2 = count(count) if group == 2 & Bin80 == 10;
   bysort ydate qdate: egen HighBin3 = count(count) if group == 3 & Bin80 == 14;
   bysort ydate qdate: egen HighBin4 = count(count) if group == 4 & Bin80 == 12;

   replace HighBin1 = 0 if HighBin1 == .;
   replace HighBin2 = 0 if HighBin2 == .;
   replace HighBin3 = 0 if HighBin3 == .;
   replace HighBin4 = 0 if HighBin4 == .;

   gen HighBin = HighBin1 + HighBin2 + HighBin3 + HighBin4;
   drop HighBin1 HighBin2 HighBin3 HighBin4;
   replace HighBin = . if HighBin == 0;

   bysort ydate qdate: egen MaxBin1 = count(count) if group == 1 & Bin99 == 9;
   bysort ydate qdate: egen MaxBin2 = count(count) if group == 2 & Bin99 == 10;
   bysort ydate qdate: egen MaxBin3 = count(count) if group == 3 & Bin99 == 14;
   bysort ydate qdate: egen MaxBin4 = count(count) if group == 4 & Bin99 == 12;

   replace MaxBin1 = 0 if MaxBin1 == .;
   replace MaxBin2 = 0 if MaxBin2 == .;
   replace MaxBin3 = 0 if MaxBin3 == .;
   replace MaxBin4 = 0 if MaxBin4 == .;

   
   gen MaxBin = MaxBin1 + MaxBin2 + MaxBin3 + MaxBin4;
   drop MaxBin1 MaxBin2 MaxBin3 MaxBin4;
   replace MaxBin = . if MaxBin == 0;
   
   gen iqr = P75-P25;
   bysort ydate qdate: egen iqr_mean = mean(iqr);
   bysort ydate qdate: egen iqr_uncertainty_med = median(iqr);
   bysort ydate qdate: egen iqr_uncertainty_25 = pctile(iqr), p(25);
   bysort ydate qdate: egen iqr_uncertainty_75 = pctile(iqr), p(75);
   bysort ydate qdate: egen iqr_uncertainty_50 = pctile(iqr), p(50);
   bysort ydate qdate: egen iqr_uncertainty_10 = pctile(iqr), p(10);
   bysort ydate qdate: egen iqr_uncertainty_90 = pctile(iqr), p(90);
   bysort ydate qdate: egen iqr_disagreement = iqr(point);

   //collapse iqr_uncertainty iqr_disagreement, by(ydate qdate);
   collapse iqr_mean iqr_uncertainty_med iqr_uncertainty_25 iqr_uncertainty_75 iqr_uncertainty_50 iqr_uncertainty_90 iqr_uncertainty_10 iqr_disagreement HighBin LowBin MaxBin MinBin, by(ydate qdate);
   replace HighBin = 0 if HighBin == .;
   replace LowBin = 0 if LowBin == .;
   replace MaxBin = 0 if MaxBin == .;
   replace MinBin = 0 if MinBin == .;
   outsheet using  output/hicp/laxhicp_Percentile`x'_iqr_`sampcut'.csv, replace;
};
};
