/************************************************************************
   TotalResponses.do
   Hannah Herman - 6/2/2014

   Description: Calculate number of responses and number of invalid responses
   for the web appendix.

*********************************************************************/
clear all
set more off
	
foreach type in HICP GDP urate {
	foreach horizon in A B 5 {
		local low = lower("`type'")
		
		if "`horizon'"=="5" {
			use data/`low'fiveyr.dta, clear
		}
		else {
			use data/`low'`horizon'roll.dta, clear
		}
		gen invalid = (nopoint | sum1 | sum0)			
		keep invalid
	
		collapse (sum) invalid (count) N=invalid
		gen variable = "`type'"
		gen horizon = "`horizon'"
		
		if "`type'"=="HICP" & "`horizon'"=="A" {
			save output/results/invalid_obs.dta, replace
		}
		else {
			append using output/results/invalid_obs.dta
			save output/results/invalid_obs.dta, replace
		}
		
	}
}
order variable horizon invalid N	
export excel using output/results/InvalidResponses.xlsx, replace firstrow(variables)	
	
