/************************************************************************
   ZL.do
   3/3/14
   Kaivan K. Sattar

   Description: Calculates the Z&L measure of individual uncertainty

   *********************************************************************/
clear all
set more off

*	1. HICP
foreach sampcut in 5 10 15 20 25 100 {	
	local data "A B 5"
	foreach x of local data {
		use output/hicp/laxhicp_Percentile`x'_`sampcut'.dta, clear
		replace left1 = left1 - 0.05
		
		drop if sum0 == 1
		drop if sum1 == 1
		drop if nopoint == 1

		order ydate qdate year month person point a* left1 left* P* Bin*
		
*		bins 9-10-14-12
*		ZL method
		gen ZL_first = .
		replace ZL_first = a1*(((left2)^2 - (left1)^2)/2)/(left2 - left1) + a2*(((left3)^2 - (left2)^2)/2)/(left3 - left2) + a3*(((left4)^2 - (left3)^2)/2)/(left4 - left3) + a4*(((left5)^2 - (left4)^2)/2)/(left5 - left4) + a5*(((left6)^2 - (left5)^2)/2)/(left6 - left5) + a6*(((left7)^2 - (left6)^2)/2)/(left7 - left6) + a7*(((left8)^2 - (left7)^2)/2)/(left8 - left7) + a8*(((left9)^2 - (left8)^2)/2)/(left9 - left8) + a9*(((left9 + 1)^2 - (left9)^2)/2)/((left9 + 1) - left9) if group == 1
		replace ZL_first = a1*(((left2)^2 - (left1)^2)/2)/(left2 - left1) + a2*(((left3)^2 - (left2)^2)/2)/(left3 - left2) + a3*(((left4)^2 - (left3)^2)/2)/(left4 - left3) + a4*(((left5)^2 - (left4)^2)/2)/(left5 - left4) + a5*(((left6)^2 - (left5)^2)/2)/(left6 - left5) + a6*(((left7)^2 - (left6)^2)/2)/(left7 - left6) + a7*(((left8)^2 - (left7)^2)/2)/(left8 - left7) + a8*(((left9)^2 - (left8)^2)/2)/(left9 - left8) + a9*(((left10)^2 - (left9)^2)/2)/(left10 - left9) + a10*(((left10 + 1)^2 - (left10)^2)/2)/((left10 + 1) - left10) if group == 2
		replace ZL_first = a1*(((left2)^2 - (left1)^2)/2)/(left2 - left1) + a2*(((left3)^2 - (left2)^2)/2)/(left3 - left2) + a3*(((left4)^2 - (left3)^2)/2)/(left4 - left3) + a4*(((left5)^2 - (left4)^2)/2)/(left5 - left4) + a5*(((left6)^2 - (left5)^2)/2)/(left6 - left5) + a6*(((left7)^2 - (left6)^2)/2)/(left7 - left6) + a7*(((left8)^2 - (left7)^2)/2)/(left8 - left7) + a8*(((left9)^2 - (left8)^2)/2)/(left9 - left8) + a9*(((left10)^2 - (left9)^2)/2)/(left10 - left9) + a10*(((left11)^2 - (left10)^2)/2) + a11*(((left12)^2 - (left11)^2)/2)/(left12 - left11) + a12*(((left13)^2 - (left12)^2)/2)/(left13 - left12) + a13*(((left14)^2 - (left13)^2)/2)/(left14 - left13) + a14*(((left14 + 1)^2 - (left14)^2)/2)/((left14 + 1) - left14) if group == 3
		replace ZL_first = a1*(((left2)^2 - (left1)^2)/2)/(left2 - left1) + a2*(((left3)^2 - (left2)^2)/2)/(left3 - left2) + a3*(((left4)^2 - (left3)^2)/2)/(left4 - left3) + a4*(((left5)^2 - (left4)^2)/2)/(left5 - left4) + a5*(((left6)^2 - (left5)^2)/2)/(left6 - left5) + a6*(((left7)^2 - (left6)^2)/2)/(left7 - left6) + a7*(((left8)^2 - (left7)^2)/2)/(left8 - left7) + a8*(((left9)^2 - (left8)^2)/2)/(left9 - left8) + a9*(((left10)^2 - (left9)^2)/2)/(left10 - left9) + a10*(((left11)^2 - (left10)^2)/2) + a11*(((left12)^2 - (left11)^2)/2)/(left12 - left11) + a12*(((left12 + 1)^2 - (left12)^2)/2)/((left12 + 1) - left12) if group == 4

		gen ZL_second = .
		replace ZL_second = a1*(((left2)^3 - (left1)^3)/3)/(left2 - left1) + a2*(((left3)^3 - (left2)^3)/3)/(left3 - left2) + a3*(((left4)^3 - (left3)^3)/3)/(left4 - left3) + a4*(((left5)^3 - (left4)^3)/3)/(left5 - left4) + a5*(((left6)^3 - (left5)^3)/3)/(left6 - left5) + a6*(((left7)^3 - (left6)^3)/3)/(left7 - left6) + a7*(((left8)^3 - (left7)^3)/3)/(left8 - left7) + a8*(((left9)^3 - (left8)^3)/3)/(left9 - left8) + a9*(((left9 + 1)^3 - (left9)^3)/3)/((left9 + 1) - left9) if group == 1
		replace ZL_second = a1*(((left2)^3 - (left1)^3)/3)/(left2 - left1) + a2*(((left3)^3 - (left2)^3)/3)/(left3 - left2) + a3*(((left4)^3 - (left3)^3)/3)/(left4 - left3) + a4*(((left5)^3 - (left4)^3)/3)/(left5 - left4) + a5*(((left6)^3 - (left5)^3)/3)/(left6 - left5) + a6*(((left7)^3 - (left6)^3)/3)/(left7 - left6) + a7*(((left8)^3 - (left7)^3)/3)/(left8 - left7) + a8*(((left9)^3 - (left8)^3)/3)/(left9 - left8) + a9*(((left10)^3 - (left9)^3)/3)/(left10 - left9) + a10*(((left10 + 1)^3 - (left10)^3)/3)/((left10 + 1) - left10) if group == 2
		replace ZL_second = a1*(((left2)^3 - (left1)^3)/3)/(left2 - left1) + a2*(((left3)^3 - (left2)^3)/3)/(left3 - left2) + a3*(((left4)^3 - (left3)^3)/3)/(left4 - left3) + a4*(((left5)^3 - (left4)^3)/3)/(left5 - left4) + a5*(((left6)^3 - (left5)^3)/3)/(left6 - left5) + a6*(((left7)^3 - (left6)^3)/3)/(left7 - left6) + a7*(((left8)^3 - (left7)^3)/3)/(left8 - left7) + a8*(((left9)^3 - (left8)^3)/3)/(left9 - left8) + a9*(((left10)^3 - (left9)^3)/3)/(left10 - left9) + a10*(((left11)^3 - (left10)^3)/3) + a11*(((left12)^3 - (left11)^3)/3)/(left12 - left11) + a12*(((left13)^3 - (left12)^3)/3)/(left13 - left12) + a13*(((left14)^3 - (left13)^3)/3)/(left14 - left13) + a14*(((left14 + 1)^3 - (left14)^3)/3)/((left14 + 1) - left14) if group == 3
		replace ZL_second = a1*(((left2)^3 - (left1)^3)/3)/(left2 - left1) + a2*(((left3)^3 - (left2)^3)/3)/(left3 - left2) + a3*(((left4)^3 - (left3)^3)/3)/(left4 - left3) + a4*(((left5)^3 - (left4)^3)/3)/(left5 - left4) + a5*(((left6)^3 - (left5)^3)/3)/(left6 - left5) + a6*(((left7)^3 - (left6)^3)/3)/(left7 - left6) + a7*(((left8)^3 - (left7)^3)/3)/(left8 - left7) + a8*(((left9)^3 - (left8)^3)/3)/(left9 - left8) + a9*(((left10)^3 - (left9)^3)/3)/(left10 - left9) + a10*(((left11)^3 - (left10)^3)/3) + a11*(((left12)^3 - (left11)^3)/3)/(left12 - left11) + a12*(((left12 + 1)^3 - (left12)^3)/3)/((left12 + 1) - left12) if group == 4
		
		gen ZL_var_HICP_`x' = ZL_second - (ZL_first)^2
		gen ZL_SD_HICP_`x' = sqrt(ZL_var_HICP_`x')
		bysort ydate qdate: egen HICP_`x'_WallDisag = sd(point)
		save output/hicp/ZL_HICP_`x'_`sampcut', replace
	}

*	2. GDP
	local data "A B 5"
	foreach x of local data {
		use output/gdp/laxgdp_Percentile`x'_`sampcut'.dta, clear
		replace b1 =  b1 - 0.05
		
		drop if sum0 == 1
		drop if sum1 == 1
		drop if nopoint == 1

		order ydate qdate year quarter person point a* b1 b* P* Bin*
		
*		bins 10-12-12-22
*		ZL method
		gen ZL_first = .
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b9)^2 - (b8)^2)/2)/(b9 - b8) + a9*(((b10)^2 - (b9)^2)/2)/(b10 - b9) + a10*(((b10 + 1)^2 - (b10)^2)/2) if group == 1
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b9)^2 - (b8)^2)/2)/(b9 - b8) + a9*(((b10)^2 - (b9)^2)/2)/(b10 - b9) + a10*(((b11)^2 - (b10)^2)/2)/(b11 - b10) + a11*(((b12)^2 - (b11)^2)/2)/(b12 - b11) + a12*(((b12 + 1)^2 - (b12)^2)/2)/((b12 + 1) - b12) if group == 2
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b9)^2 - (b8)^2)/2)/(b9 - b8) + a9*(((b10)^2 - (b9)^2)/2)/(b10 - b9) + a10*(((b11)^2 - (b10)^2)/2)/(b11 - b10) + a11*(((b12)^2 - (b11)^2)/2)/(b12 - b11) + a12*(((b12 + 1)^2 - (b12)^2)/2)/((b12 + 1) - b12) if group == 3
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b9)^2 - (b8)^2)/2)/(b9 - b8) + a9*(((b10)^2 - (b9)^2)/2)/(b10 - b9) + a10*(((b11)^2 - (b10)^2)/2)/(b11 - b10) + a11*(((b12)^2 - (b11)^2)/2)/(b12 - b11) + a12*(((b13)^2 - (b12)^2)/2)/(b13 - b12) + a13*(((b14)^2 - (b13)^2)/2)/(b14 - b13) + a14*(((b15)^2 - (b14)^2)/2)/(b15 - b14) + a15*(((b16)^2 - (b15)^2)/2)/(b16 - b15) + a16*(((b17)^2 - (b16)^2)/2)/(b17 - b16) + a17*(((b18)^2 - (b17)^2)/2)/(b18 - b17) + a18*(((b19)^2 - (b18)^2)/2)/(b19 - b18) + a19*(((b20)^2 - (b19)^2)/2)/(b20 - b19) + a20*(((b21)^2 - (b20)^2)/2)/(b21 - b20) + a21*(((b22)^2 - (b21)^2)/2)/(b22 - b21) + a22*(((b22 + 1)^2 - (b22)^2)/2)/((b22 + 1) - b22) if group == 4

		gen ZL_second = .
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b9)^3 - (b8)^3)/3)/(b9 - b8) + a9*(((b10)^3 - (b9)^3)/3)/(b10 - b9) + a10*(((b10 + 1)^3 - (b10)^3)/3) if group == 1
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b9)^3 - (b8)^3)/3)/(b9 - b8) + a9*(((b10)^3 - (b9)^3)/3)/(b10 - b9) + a10*(((b11)^3 - (b10)^3)/3)/(b11 - b10) + a11*(((b12)^3 - (b11)^3)/3)/(b12 - b11) + a12*(((b12 + 1)^3 - (b12)^3)/3)/((b12 + 1) - b12) if group == 2
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b9)^3 - (b8)^3)/3)/(b9 - b8) + a9*(((b10)^3 - (b9)^3)/3)/(b10 - b9) + a10*(((b11)^3 - (b10)^3)/3)/(b11 - b10) + a11*(((b12)^3 - (b11)^3)/3)/(b12 - b11) + a12*(((b12 + 1)^3 - (b12)^3)/3)/((b12 + 1) - b12) if group == 3
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b9)^3 - (b8)^3)/3)/(b9 - b8) + a9*(((b10)^3 - (b9)^3)/3)/(b10 - b9) + a10*(((b11)^3 - (b10)^3)/3)/(b11 - b10) + a11*(((b12)^3 - (b11)^3)/3)/(b12 - b11) + a12*(((b13)^3 - (b12)^3)/3)/(b13 - b12) + a13*(((b14)^3 - (b13)^3)/3)/(b14 - b13) + a14*(((b15)^3 - (b14)^3)/3)/(b15 - b14) + a15*(((b16)^3 - (b15)^3)/3)/(b16 - b15) + a16*(((b17)^3 - (b16)^3)/3)/(b17 - b16) + a17*(((b18)^3 - (b17)^3)/3)/(b18 - b17) + a18*(((b19)^3 - (b18)^3)/3)/(b19 - b18) + a19*(((b20)^3 - (b19)^3)/3)/(b20 - b19) + a20*(((b21)^3 - (b20)^3)/3)/(b21 - b20) + a21*(((b22)^3 - (b21)^3)/3)/(b22 - b21) + a22*(((b22 + 1)^3 - (b22)^3)/3)/((b22 + 1) - b22) if group == 4

		gen ZL_var_GDP_`x' = ZL_second - (ZL_first)^2
		gen ZL_SD_GDP_`x' = sqrt(ZL_var_GDP_`x')
		bysort ydate qdate: egen GDP_`x'_WallDisag = sd(point)
		save output/gdp/ZL_GDP_`x'_`sampcut', replace
	}

*	3. Unemployment
	local data "A B 5"
	foreach x of local data {
		use output/urate/laxurate_Percentile`x'_`sampcut'.dta, clear
		replace b1 =  b1 - 0.05
		
		drop if sum0 == 1
		drop if sum1 == 1
		drop if nopoint == 1

		order ydate qdate year month person point a* b1 b* P* Bin*
		
*		bins 8-11-11-13-13-21-19
*		ZL method
		gen ZL_first = .
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b8 + 1)^2 - (b8)^2)/2)/((b8 + 1) - b8) if group == 1
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b9)^2 - (b8)^2)/2)/(b9 - b8) + a9*(((b10)^2 - (b9)^2)/2)/(b10 - b9) + a10*(((b11)^2 - (b10)^2)/2)/(b11 - b10) + a11*(((b11 + 1)^2 - (b11)^2)/2)/((b11 + 1) - b11) if group == 2
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b9)^2 - (b8)^2)/2)/(b9 - b8) + a9*(((b10)^2 - (b9)^2)/2)/(b10 - b9) + a10*(((b11)^2 - (b10)^2)/2)/(b11 - b10) + a11*(((b11 + 1)^2 - (b11)^2)/2)/((b11 + 1) - b11) if group == 3
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b9)^2 - (b8)^2)/2)/(b9 - b8) + a9*(((b10)^2 - (b9)^2)/2)/(b10 - b9) + a10*(((b11)^2 - (b10)^2)/2)/(b11 - b10) + a11*(((b12)^2 - (b11)^2)/2)/(b12 - b11) + a12*(((b13)^2 - (b12)^2)/2)/(b13 - b12) + a13*(((b13 + 1)^2 - (b13)^2)/2)/((b13 + 1) - b13) if group == 4
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b9)^2 - (b8)^2)/2)/(b9 - b8) + a9*(((b10)^2 - (b9)^2)/2)/(b10 - b9) + a10*(((b11)^2 - (b10)^2)/2)/(b11 - b10) + a11*(((b12)^2 - (b11)^2)/2)/(b12 - b11) + a12*(((b13)^2 - (b12)^2)/2)/(b13 - b12) + a13*(((b13 + 1)^2 - (b13)^2)/2)/((b13 + 1) - b13) if group == 5
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b9)^2 - (b8)^2)/2)/(b9 - b8) + a9*(((b10)^2 - (b9)^2)/2)/(b10 - b9) + a10*(((b11)^2 - (b10)^2)/2)/(b11 - b10) + a11*(((b12)^2 - (b11)^2)/2)/(b12 - b11) + a12*(((b13)^2 - (b12)^2)/2)/(b13 - b12) + a13*(((b14)^2 - (b13)^2)/2)/(b14 - b13) + a14*(((b15)^2 - (b14)^2)/2)/(b15 - b14) + a15*(((b16)^2 - (b15)^2)/2)/(b16 - b15) + a16*(((b17)^2 - (b16)^2)/2)/(b17 - b16) + a17*(((b18)^2 - (b17)^2)/2)/(b18 - b17) + a18*(((b19)^2 - (b18)^2)/2)/(b19 - b18) + a19*(((b20)^2 - (b19)^2)/2)/(b20 - b19) + a20*(((b21)^2 - (b20)^2)/2)/(b21 - b20) + a21*(((b21 + 1)^2 - (b21)^2)/2)/((b21 + 1) - b21) if group == 6
		replace ZL_first = a1*(((b2)^2 - (b1)^2)/2)/(b2 - b1) + a2*(((b3)^2 - (b2)^2)/2)/(b3 - b2) + a3*(((b4)^2 - (b3)^2)/2)/(b4 - b3) + a4*(((b5)^2 - (b4)^2)/2)/(b5 - b4) + a5*(((b6)^2 - (b5)^2)/2)/(b6 - b5) + a6*(((b7)^2 - (b6)^2)/2)/(b7 - b6) + a7*(((b8)^2 - (b7)^2)/2)/(b8 - b7) + a8*(((b9)^2 - (b8)^2)/2)/(b9 - b8) + a9*(((b10)^2 - (b9)^2)/2)/(b10 - b9) + a10*(((b11)^2 - (b10)^2)/2)/(b11 - b10) + a11*(((b12)^2 - (b11)^2)/2)/(b12 - b11) + a12*(((b13)^2 - (b12)^2)/2)/(b13 - b12) + a13*(((b14)^2 - (b13)^2)/2)/(b14 - b13) + a14*(((b15)^2 - (b14)^2)/2)/(b15 - b14) + a15*(((b16)^2 - (b15)^2)/2)/(b16 - b15) + a16*(((b17)^2 - (b16)^2)/2)/(b17 - b16) + a17*(((b18)^2 - (b17)^2)/2)/(b18 - b17) + a18*(((b19)^2 - (b18)^2)/2)/(b19 - b18) + a19*(((b19 + 1)^2 - (b19)^2)/2)/((b19 + 1) - b19) if group == 7
		
		gen ZL_second = .
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b8 + 1)^3 - (b8)^3)/3)/((b8 + 1) - b8) if group == 1
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b9)^3 - (b8)^3)/3)/(b9 - b8) + a9*(((b10)^3 - (b9)^3)/3)/(b10 - b9) + a10*(((b11)^3 - (b10)^3)/3)/(b11 - b10) + a11*(((b11 + 1)^3 - (b11)^3)/3)/((b11 + 1) - b11) if group == 2
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b9)^3 - (b8)^3)/3)/(b9 - b8) + a9*(((b10)^3 - (b9)^3)/3)/(b10 - b9) + a10*(((b11)^3 - (b10)^3)/3)/(b11 - b10) + a11*(((b11 + 1)^3 - (b11)^3)/3)/((b11 + 1) - b11) if group == 3
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b9)^3 - (b8)^3)/3)/(b9 - b8) + a9*(((b10)^3 - (b9)^3)/3)/(b10 - b9) + a10*(((b11)^3 - (b10)^3)/3)/(b11 - b10) + a11*(((b12)^3 - (b11)^3)/3)/(b12 - b11) + a12*(((b13)^3 - (b12)^3)/3)/(b13 - b12) + a13*(((b13 + 1)^3 - (b13)^3)/3)/((b13 + 1) - b13) if group == 4
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b9)^3 - (b8)^3)/3)/(b9 - b8) + a9*(((b10)^3 - (b9)^3)/3)/(b10 - b9) + a10*(((b11)^3 - (b10)^3)/3)/(b11 - b10) + a11*(((b12)^3 - (b11)^3)/3)/(b12 - b11) + a12*(((b13)^3 - (b12)^3)/3)/(b13 - b12) + a13*(((b13 + 1)^3 - (b13)^3)/3)/((b13 + 1) - b13) if group == 5
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b9)^3 - (b8)^3)/3)/(b9 - b8) + a9*(((b10)^3 - (b9)^3)/3)/(b10 - b9) + a10*(((b11)^3 - (b10)^3)/3)/(b11 - b10) + a11*(((b12)^3 - (b11)^3)/3)/(b12 - b11) + a12*(((b13)^3 - (b12)^3)/3)/(b13 - b12) + a13*(((b14)^3 - (b13)^3)/3)/(b14 - b13) + a14*(((b15)^3 - (b14)^3)/3)/(b15 - b14) + a15*(((b16)^3 - (b15)^3)/3)/(b16 - b15) + a16*(((b17)^3 - (b16)^3)/3)/(b17 - b16) + a17*(((b18)^3 - (b17)^3)/3)/(b18 - b17) + a18*(((b19)^3 - (b18)^3)/3)/(b19 - b18) + a19*(((b20)^3 - (b19)^3)/3)/(b20 - b19) + a20*(((b21)^3 - (b20)^3)/3)/(b21 - b20) + a21*(((b21 + 1)^3 - (b21)^3)/3)/((b21 + 1) - b21) if group == 6
		replace ZL_second = a1*(((b2)^3 - (b1)^3)/3)/(b2 - b1) + a2*(((b3)^3 - (b2)^3)/3)/(b3 - b2) + a3*(((b4)^3 - (b3)^3)/3)/(b4 - b3) + a4*(((b5)^3 - (b4)^3)/3)/(b5 - b4) + a5*(((b6)^3 - (b5)^3)/3)/(b6 - b5) + a6*(((b7)^3 - (b6)^3)/3)/(b7 - b6) + a7*(((b8)^3 - (b7)^3)/3)/(b8 - b7) + a8*(((b9)^3 - (b8)^3)/3)/(b9 - b8) + a9*(((b10)^3 - (b9)^3)/3)/(b10 - b9) + a10*(((b11)^3 - (b10)^3)/3)/(b11 - b10) + a11*(((b12)^3 - (b11)^3)/3)/(b12 - b11) + a12*(((b13)^3 - (b12)^3)/3)/(b13 - b12) + a13*(((b14)^3 - (b13)^3)/3)/(b14 - b13) + a14*(((b15)^3 - (b14)^3)/3)/(b15 - b14) + a15*(((b16)^3 - (b15)^3)/3)/(b16 - b15) + a16*(((b17)^3 - (b16)^3)/3)/(b17 - b16) + a17*(((b18)^3 - (b17)^3)/3)/(b18 - b17) + a18*(((b19)^3 - (b18)^3)/3)/(b19 - b18) + a19*(((b19 + 1)^3 - (b19)^3)/3)/((b19 + 1) - b19) if group == 7
		
		gen ZL_var_Urate_`x' = ZL_second - (ZL_first)^2
		gen ZL_SD_Urate_`x' = sqrt(ZL_var_Urate_`x')
		bysort ydate qdate: egen Urate_`x'_WallDisag = sd(point)
		save output/urate/ZL_Urate_`x'_`sampcut', replace
	}

*	4. Append
	use output/hicp/ZL_HICP_A_`sampcut', clear
	append using output/hicp/ZL_HICP_B_`sampcut' output/hicp/ZL_HICP_5_`sampcut'
	summ ZL_SD*	
	preserve
	collapse ZL_var* ZL_SD* *WallDisag, by(ydate qdate)
	save output/hicp/ZL_HICP_mean_`sampcut', replace
	restore
	collapse (p50) ZL_var* ZL_SD* *WallDisag, by(ydate qdate)
	drop *WallDisag
	save output/hicp/ZL_HICP_median_`sampcut', replace
	
	use output/gdp/ZL_GDP_A_`sampcut', clear
	append using output/gdp/ZL_GDP_B_`sampcut' output/gdp/ZL_GDP_5_`sampcut'
	summ ZL_SD*
	preserve
	collapse ZL_var* ZL_SD* *WallDisag, by(ydate qdate)
	save output/gdp/ZL_GDP_mean_`sampcut', replace
	restore
	collapse (p50) ZL_var* ZL_SD* *WallDisag, by(ydate qdate)
	drop *WallDisag
	save output/gdp/ZL_GDP_median_`sampcut', replace
	
	use output/urate/ZL_Urate_A_`sampcut', clear
	append using output/urate/ZL_Urate_B_`sampcut' output/urate/ZL_Urate_5_`sampcut'
	summ ZL_SD*
	preserve
	collapse ZL_var* ZL_SD* *WallDisag, by(ydate qdate)
	save output/urate/ZL_Urate_mean_`sampcut', replace
	restore
	collapse (p50) ZL_var* ZL_SD* *WallDisag, by(ydate qdate)
	drop *WallDisag
	save output/urate/ZL_Urate_median_`sampcut', replace
	
}
